/////////////////////////////////////////////////////////////////////
// Taschenrechner
/////////////////////////////////////////////////////////////////////

#include <stdlib.h>

extern "C"
{
#include "lcd.h"
//#include "usart.h"
// #include "memcheck.h"
#include "rc5.h"
}

#define uint unsigned int

#include "Gleitkomma.h"

#define RC5_COMMAND_FOR_RESET 14
#define RC5_COMMAND_FOR_DECIMAL_POINT 28
#define RC5_COMMAND_FOR_PLUS 16
#define RC5_COMMAND_FOR_MINUS 17
#define RC5_COMMAND_FOR_MULT 18
#define RC5_COMMAND_FOR_DIV 19
#define RC5_COMMAND_FOR_RESULT 30

const uint8 RC5CommandsForDigits[10]=
{
	0, 1, 2, 3, 4, 5, 6, 7, 8, 9
};

int main(void)
{
    lcd_init(LCD_DISP_ON);
	rc5_init();
	//usart_init(9600);

    lcd_clrscr();
    lcd_puts("Taschenrechner");

	real z1;

	while(!read_rc5())
		;	// Auf Tastendruck warten
	
	static char s[2][33], op[2];
	static char buffer[33];
	uint8 i;
	uint j;

	while(1)
	{
reset:
		bool z1_initialisiert=false;
		s[0][0]=0;
		op[0]=0;

eingabe:
		lcd_clrscr();
		lcd_gotoxy(0,0);
		lcd_puts(0==s[0][0] ? "0" : s[0]);
		if(0!=op[0])
		{
			lcd_gotoxy(15,0);
			buffer[0]=op[0]; buffer[1]=0;
			lcd_puts(buffer);
		}

		for(uint8 nop=0 ; nop<2 ; nop++)
		{
			bool komma=false, first=true;
			char *sa=s[nop], *aop=&op[nop];
			uint n=strlen(sa);
			s[1][0]=0;
			op[1]=0;

			if(0==*aop || 0!=nop)
			while(1)
			{
				while(0==(j=read_rc5()) || RC5_IS_REPEAT(j))
					;
				i=RC5_KEY_CODE(j);
				if(RC5_COMMAND_FOR_RESET==i)
					goto reset;
				for(j=0 ; j<10 && RC5CommandsForDigits[j]!=i ; j++)
					;
				if(10!=j || (!komma && RC5_COMMAND_FOR_DECIMAL_POINT==i))
				{
					if(0==nop)
						z1_initialisiert=false;
					if(0==*aop && first && 0==nop)
						{ sa[0]=0; n=0; lcd_clrscr(); }
					first=false;
					if(n<15)
					{
						if(RC5_COMMAND_FOR_DECIMAL_POINT==i)
						{
							komma=true;
							if(0==sa[0] || ('0'==sa[0] && 0==sa[1]))
								sa[n++]='0';
						}
						if(0!=i || 0!=sa[0])
							sa[n++]=(RC5_COMMAND_FOR_DECIMAL_POINT==i) ? '.' : ('0'+j);
						sa[n]=0;
						lcd_gotoxy(0,nop);
						lcd_puts(0==sa[0] ? "0" : sa);
					}
				}
				bool is_op=false;
				if(RC5_COMMAND_FOR_PLUS==i)
					{ *aop='+'; is_op=true; }
				else if(RC5_COMMAND_FOR_MINUS==i)
					{ *aop='-'; is_op=true; }
				else if(RC5_COMMAND_FOR_MULT==i)
					{ *aop='*'; is_op=true; }
				else if(RC5_COMMAND_FOR_DIV==i)
					{ *aop='/'; is_op=true; }
				else if(RC5_COMMAND_FOR_RESULT==i)
					{ *aop='='; is_op=true; }

				if(is_op)
				{
					if(0!=nop && first)
						nop=0; // Es wurden zwei Operatoren (+, -, *, /) unmittelbar hintereinander gedrckt
						// ==> Den letzten Operator verwenden und auf Eingabe des zweiten Operanden warten.
					if(0==nop) 
					{	// hier KEIN else if !
						if('='==*aop)
							{ op[0]=0; goto eingabe; }
						lcd_gotoxy(15,0);
						buffer[0]=*aop; buffer[1]=0;
						lcd_puts(buffer);
					}
					break;
				}
			}			
		}
		
		if(!z1_initialisiert)
			z1=real(s[0]);
		if(op[0]=='+')
			z1=z1+real(s[1]);
		else if(op[0]=='-')
			z1=z1-real(s[1]);
		else if(op[0]=='*')
			z1=z1*real(s[1]);
		else if(op[0]=='/')
			z1=z1/real(s[1]);
		
		strcpy(s[0], z1.optimal_decimal_representation(15));
		//strcpy(s[0], z1.to_decimalExp(9));
		
		op[0]=(op[1]=='=') ? 0 : op[1];
		z1_initialisiert=true;
		goto eingabe;
	}
}
